diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
index 4d9198b55..0beeb1bda 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
@@ -6,6 +6,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
@@ -27,7 +28,7 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
                             DoubleCoordinates targetCoordinates = c.getArgument("position", DoubleCoordinates.class);
 
                             if (source.getSender() != null) {
-                                source.getSender().moveTo(targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source), source.getSender().yRot, source.getSender().xRot);
+                                source.teleportPlayerToPos(source.getSender(), targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
                                 source.sendTranslatableMessage("command.commands.teleport.location.success_single_entity", source.getSender().getDisplayName(), targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
                             } else {
                                 throw CommandExceptions.notInWorld().create();
@@ -44,7 +45,11 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
 
                                     List<? extends Entity> entities = entitySelector.get(source);
                                     for (Entity entity : entities) {
-                                        entity.moveTo(targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source), entity.yRot, entity.xRot);
+                                        if (entity instanceof Player) {
+                                            source.teleportPlayerToPos((Player) entity, targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
+                                        } else {
+                                            entity.moveTo(targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source), entity.yRot, entity.xRot);
+                                        }
                                     }
 
                                     double x = targetCoordinates.getX(source);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
index f8d01420f..915d3165c 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
@@ -56,7 +56,9 @@ public class EntitySelector {
                     entities.add(entity);
                 }
             }
-            return entities.subList(0, Math.min(entities.size(), this.maxResults));
+            List<Entity> list = entities.subList(0, Math.min(entities.size(), this.maxResults));
+            if (list.isEmpty()) throw CommandExceptions.emptySelector().create();
+            return list;
         } else if (this.playerName != null) {
             List<Player> players = new ArrayList<>();
             for (Player player : source.getWorld().players) {
@@ -64,7 +66,9 @@ public class EntitySelector {
                     players.add(player);
                 }
             }
-            return players.subList(0, Math.min(players.size(), this.maxResults));
+            List<Player> list = players.subList(0, Math.min(players.size(), this.maxResults));
+            if (list.isEmpty()) throw CommandExceptions.emptySelector().create();
+            return list;
         }
 
         List<? extends Entity> entities;
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
index e96edefe4..357d36376 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
@@ -2,17 +2,18 @@ package net.minecraft.core.player.inventory.container;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.Nullable;
 
 public interface Container
 {
 
     int getContainerSize();
 
-    ItemStack getItem(int index);
+    @Nullable ItemStack getItem(int index);
 
-    ItemStack removeItem(int index, int takeAmount);
+    @Nullable ItemStack removeItem(int index, int takeAmount);
 
-    void setItem(int index, ItemStack itemstack);
+    void setItem(int index, @Nullable ItemStack itemstack);
 
     String getNameTranslationKey();
 
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
index 401af74ea..b9896ff91 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
@@ -3,6 +3,7 @@ package net.minecraft.core.player.inventory.container;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.InventorySorter;
+import org.jetbrains.annotations.Nullable;
 
 public class ContainerCompound
     implements Container
@@ -31,7 +32,7 @@ public class ContainerCompound
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         if(index >= c1.getContainerSize())
         {
@@ -43,7 +44,7 @@ public class ContainerCompound
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(index >= c1.getContainerSize())
         {
@@ -55,7 +56,7 @@ public class ContainerCompound
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         if(index >= c1.getContainerSize())
         {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
index 25748cb99..9e806cdcd 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
@@ -3,6 +3,7 @@ package net.minecraft.core.player.inventory.container;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.menu.MenuAbstract;
+import org.jetbrains.annotations.Nullable;
 
 public class ContainerCrafting
     implements Container
@@ -26,7 +27,7 @@ public class ContainerCrafting
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         if(index >= getContainerSize())
         {
@@ -68,7 +69,7 @@ public class ContainerCrafting
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(items[index] != null)
         {
@@ -93,7 +94,7 @@ public class ContainerCrafting
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         items[index] = itemstack;
         menu.slotsChanged(this);
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index 8fef34a37..6f7dafafd 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -237,7 +237,7 @@ public class ContainerInventory
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         ItemStack aitemstack[] = mainInventory;
         if(index >= mainInventory.length)
@@ -266,7 +266,7 @@ public class ContainerInventory
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         ItemStack aitemstack[] = mainInventory;
         if(index >= aitemstack.length)
@@ -346,7 +346,7 @@ public class ContainerInventory
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         ItemStack aitemstack[] = mainInventory;
         if(index >= aitemstack.length)
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
index d8fefbe4f..8146062fd 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
@@ -2,6 +2,7 @@ package net.minecraft.core.player.inventory.container;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.Nullable;
 
 public class ContainerResult
     implements Container
@@ -20,7 +21,7 @@ public class ContainerResult
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         return items[index];
     }
@@ -32,7 +33,7 @@ public class ContainerResult
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(items[index] != null)
         {
@@ -46,7 +47,7 @@ public class ContainerResult
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         items[index] = itemstack;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
index 759b13bf0..6986c5369 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
@@ -3,6 +3,7 @@ package net.minecraft.core.player.inventory.container;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.InventorySorter;
+import org.jetbrains.annotations.Nullable;
 
 public class ContainerSimple
     implements Container
@@ -19,13 +20,13 @@ public class ContainerSimple
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         return items[index];
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(items[index] != null)
         {
@@ -50,7 +51,7 @@ public class ContainerSimple
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         items[index] = itemstack;
         if(itemstack != null && itemstack.stackSize > getMaxStackSize())
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index 706d6c50c..f13c7e308 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -65,7 +65,7 @@ public abstract class MenuAbstract
 	{
 		List<ItemStack> itemList = new ArrayList<>();
 		for (Slot slot : slots) {
-			itemList.add(slot.getItem());
+			itemList.add(slot.getItemStack());
 		}
 
 		return itemList;
@@ -77,7 +77,7 @@ public abstract class MenuAbstract
 		for(int i = 0; i < slots.size(); i++)
 		{
 
-			ItemStack itemstack = ((Slot) slots.get(i)).getItem();
+			ItemStack itemstack = ((Slot) slots.get(i)).getItemStack();
 			ItemStack itemstack1 = (ItemStack) lastSlots.get(i);
 			if(ItemStack.areItemStacksEqual(itemstack1, itemstack))
 			{
@@ -179,7 +179,7 @@ public abstract class MenuAbstract
 
 		//Used in multiplayer to check if the item the player clicked is the same item on the server
 		ItemStack controlStack = null;
-		ItemStack stackInSlot = slot.getItem();
+		ItemStack stackInSlot = slot.getItemStack();
 		Item itemInSlot = stackInSlot != null ? stackInSlot.getItem() : null;
 		
 		if(stackInSlot != null) {
@@ -286,7 +286,7 @@ public abstract class MenuAbstract
 				if(action == InventoryAction.CREATIVE_GRAB) {
 					ItemStack stack;
 					if(amount > 0) {
-						stack = slot.getItem().copy();
+						stack = slot.getItemStack().copy();
 						stack.stackSize = amount;
 					}else {
 						stack = null;
@@ -295,7 +295,7 @@ public abstract class MenuAbstract
 				}
 				if(action == InventoryAction.CREATIVE_MOVE) {
 					if(amount > 0) {
-						ItemStack stack = slot.getItem().copy();
+						ItemStack stack = slot.getItemStack().copy();
 						stack.stackSize = amount;
 						player.inventory.insertItem(stack, false);
 					}
@@ -378,7 +378,7 @@ public abstract class MenuAbstract
 	}
 	
 	public void handleArmorEquip(Slot slot, Player player) {
-		ItemStack stackInSlot = slot.getItem();
+		ItemStack stackInSlot = slot.getItemStack();
 		if(stackInSlot == null) {
 			return;
 		}
@@ -444,8 +444,8 @@ public abstract class MenuAbstract
 			return;
 		}
 
-		ItemStack slotStack = slot.getItem();
-		ItemStack hotbarStack = hotbarSlot.getItem();
+		ItemStack slotStack = slot.getItemStack();
+		ItemStack hotbarStack = hotbarSlot.getItemStack();
 
 		if(slotStack != null) {
 			slot.set(null);
@@ -470,7 +470,7 @@ public abstract class MenuAbstract
 	 * Handles all MOVE actions
 	 */
 	public void handleItemMove(InventoryAction action, Slot slot, int target, Player player) {
-		ItemStack stackInSlot = slot.getItem();
+		ItemStack stackInSlot = slot.getItemStack();
 
 		if(slot instanceof SlotResult) {
 			handleCrafting(action, (SlotResult) slot, target, player);
@@ -523,7 +523,7 @@ public abstract class MenuAbstract
 				if(slot1 == null) {
 					continue;
 				}
-				ItemStack item = slot1.getItem();
+				ItemStack item = slot1.getItemStack();
 				if(compare(compareStack, item)) {
 					int freeSpace = getFreeSpace(item, targetSlots);
 					if(freeSpace > 0) {
@@ -557,7 +557,7 @@ public abstract class MenuAbstract
 	 * Handle MOVE actions on crafting result slots
 	 */
 	public void handleCrafting(InventoryAction action, SlotResult slot, int target, Player player) {
-		ItemStack itemToCraft = slot.getItem();
+		ItemStack itemToCraft = slot.getItemStack();
 
 		if(itemToCraft == null) {
 			return;
@@ -581,7 +581,7 @@ public abstract class MenuAbstract
 		}
 
 		for(int i=0; i < craftCount; i++) {
-			itemToCraft = slot.getItem();
+			itemToCraft = slot.getItemStack();
 
 			if(itemToCraft == null) {
 				break;
@@ -617,7 +617,7 @@ public abstract class MenuAbstract
 			Slot slot = getSlotFromList(slots, i);
 			if(slot == null) continue;
 
-			ItemStack stackInSlot = slot.getItem();
+			ItemStack stackInSlot = slot.getItemStack();
 			if(stackInSlot == null) {
 				return max;
 			}
@@ -664,7 +664,7 @@ public abstract class MenuAbstract
 				continue;
 			}
 
-			ItemStack slotStack = slot1.getItem();
+			ItemStack slotStack = slot1.getItemStack();
 			if(slotStack == null) {
 				continue;
 			}
@@ -698,7 +698,7 @@ public abstract class MenuAbstract
 		if(action == InventoryAction.CREATIVE_DRAG) {
 			for(int i=0; i < slots.length; i++) {
 				Slot slot = getSlot(slots[i]);
-				if(slot == null || !slot.enableDragAndPickup() || !slot.mayPlace(draggingItemStack) || slot.getItem() != null) {
+				if(slot == null || !slot.enableDragAndPickup() || !slot.mayPlace(draggingItemStack) || slot.getItemStack() != null) {
 					continue;
 				}
 				ItemStack stack = draggingItemStack.copy();
@@ -729,7 +729,7 @@ public abstract class MenuAbstract
 			if(slot == null || !slot.enableDragAndPickup() || !slot.mayPlace(draggingItemStack)) {
 				continue;
 			}
-			ItemStack stackInSlot = slot.getItem();
+			ItemStack stackInSlot = slot.getItemStack();
 
 			int amount = itemsPerSlot;
 			amount = Math.min(amount, slot.getMaxStackSize());
@@ -848,7 +848,7 @@ public abstract class MenuAbstract
 		for(int i = 0; i < targetSlots.size(); i++) {
 			Slot slot = getSlotFromList(targetSlots, i);
 			if(slot == null) continue;
-			ItemStack stackInSlot = slot.getItem();
+			ItemStack stackInSlot = slot.getItemStack();
 
 			if(stackInSlot == null || !slot.mayPlace(stack) || !stack.canStackWith(stackInSlot)) continue;
 
@@ -866,7 +866,7 @@ public abstract class MenuAbstract
 		for(int i = 0; i < targetSlots.size(); i++) {
 			Slot slot = getSlotFromList(targetSlots, i);
 			if(slot == null) continue;
-			ItemStack stackInSlot = slot.getItem();
+			ItemStack stackInSlot = slot.getItemStack();
 
 			if(stackInSlot != null || !slot.mayPlace(stack)) continue;
 
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
index 794cba5ef..634b1363b 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
@@ -19,22 +19,22 @@ public class Slot
 	public Slot(final Container container, final int index, final int x, final int y)
 	{
 		this.container = container;
-		slot = index;
+        this.slot = index;
 		this.x = x;
 		this.y = y;
-		discovered = true;
+        this.discovered = true;
 	}
 
 	public void sortSlotInventory() {
-		if (container != null) {
-			container.sortContainer();
+		if (this.container != null) {
+            this.container.sortContainer();
 		}
 	}
 
-	public ItemStack remove(final int i)
+	public @Nullable ItemStack remove(final int i)
 	{
-		if (container.locked(slot)) return null;
-		return container.removeItem(slot, i);
+		if (this.container.locked(this.slot)) return null;
+		return this.container.removeItem(this.slot, i);
 	}
 
 	public @Nullable String getItemIcon()
@@ -44,27 +44,27 @@ public class Slot
 
 	public boolean hasItem()
 	{
-		return getItem() != null;
+		return getItemStack() != null;
 	}
 
 	public int getMaxStackSize()
 	{
-		return container.getMaxStackSize();
+		return this.container.getMaxStackSize();
 	}
 
-	public ItemStack getItem()
+	public @Nullable ItemStack getItemStack()
 	{
-		return container.getItem(slot);
+		return this.container.getItem(this.slot);
 	}
 
 	public boolean isAt(final Container container, final int i)
 	{
-		return container == this.container && i == slot;
+		return container == this.container && i == this.slot;
 	}
 
 	public boolean mayPlace(final ItemStack itemstack)
 	{
-		return container != null && !isLocked();
+		return this.container != null && !isLocked();
 	}
 
 	public void onTake(final ItemStack itemstack)
@@ -74,19 +74,19 @@ public class Slot
 
 	public void setChanged()
 	{
-		container.setChanged();
+        this.container.setChanged();
 	}
 
 	public Container getContainer() {
-		return container;
+		return this.container;
 	}
 
-	public void set(final ItemStack itemstack)
+	public void set(final @Nullable ItemStack itemstack)
 	{
-		container.setItem(slot, itemstack);
+        this.container.setItem(this.slot, itemstack);
 		setChanged();
 
-		if (container instanceof ContainerInventory)
+		if (this.container instanceof ContainerInventory)
 		{
 			final ContainerInventory inventory = (ContainerInventory) this.container;
 
@@ -104,12 +104,12 @@ public class Slot
 		return !isLocked();
 	}
 
-	public boolean getIsDiscovered(Player player){
-		return discovered;
+	public boolean getIsDiscovered(final Player player){
+		return this.discovered;
 	}
 
 	public boolean isLocked() {
-		return container != null && container.locked(slot);
+		return this.container != null && this.container.locked(this.slot);
 	}
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
index f1b5492e3..36d7b358c 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotArmor.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.menu.MenuInventory;
 import net.minecraft.core.player.inventory.container.Container;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.HashSet;
 import java.util.Set;
@@ -63,7 +64,7 @@ public class SlotArmor extends Slot
         {
         	if (menu.slots.get(i) instanceof SlotArmor)
         	{
-        		ItemStack stack = menu.slots.get(i).getItem();
+        		ItemStack stack = menu.slots.get(i).getItemStack();
         		if (stack != null && (stack.itemID == Items.ARMOR_BOOTS_CHAINMAIL.id || stack.itemID == Items.ARMOR_HELMET_CHAINMAIL.id || stack.itemID == Items.ARMOR_CHESTPLATE_CHAINMAIL.id || stack.itemID == Items.ARMOR_LEGGINGS_CHAINMAIL.id))
 				{
         			count++;
@@ -85,13 +86,13 @@ public class SlotArmor extends Slot
             menu.inventory.player.triggerAchievement(Achievements.ALL_ARMOR_TYPES);
         }
         
-        if (getItem() != null && container instanceof ContainerInventory) {
+        if (getItemStack() != null && container instanceof ContainerInventory) {
             Player player = ((ContainerInventory) container).player;
             player.world.playSoundAtEntity(player, player, "random.equip", 2f, 1f);
         }
     }
 
-    public void set(final ItemStack itemstack)
+    public void set(final @Nullable ItemStack itemstack)
     {
         super.set(itemstack);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotCreative.java
index 2e089d1c0..a59cca1f6 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotCreative.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.player.inventory.slot;
 
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.Nullable;
 
 public class SlotCreative extends Slot
 {
@@ -14,7 +15,7 @@ public class SlotCreative extends Slot
 
 
 	@Override
-	public ItemStack remove(final int i)
+	public @Nullable ItemStack remove(final int i)
 	{
 		if (item == null)
 		{
@@ -37,7 +38,7 @@ public class SlotCreative extends Slot
 	}
 
 	@Override
-	public ItemStack getItem()
+	public @Nullable ItemStack getItemStack()
 	{
 		if (item == null)
 		{
@@ -58,7 +59,7 @@ public class SlotCreative extends Slot
 	}
 
 	@Override
-	public void set(final ItemStack itemstack)
+	public void set(final @Nullable ItemStack itemstack)
 	{
 		return;
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Utils.java b/game/core/src/main/java/net/minecraft/core/util/helper/Utils.java
index 5a3df5ad6..7dd1202bf 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Utils.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Utils.java
@@ -40,21 +40,4 @@ public abstract class Utils {
 	public static double floor100(double d) {
 		return ((long) (d * 100)) / 100.0;
 	}
-	
-	public static void openDirectory(File file) {
-		if(!file.exists()) {
-            LOGGER.warn("Can't open directory '{}' because it doesnt exist!", file.getAbsolutePath());
-			return;
-		}
-		if(!file.isDirectory()) {
-            LOGGER.warn("Not a directory: '{}'!", file.getAbsolutePath());
-			return;
-		}
-		try {
-			Desktop.getDesktop().open(file);
-		}catch (Exception e) {
-            LOGGER.error("Error opening directory '{}'!", file.getAbsolutePath(), e);
-		}
-	}
-	
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 0f3e03456..672d41090 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2676,7 +2676,7 @@ public class World implements WorldSource {
         return blockId > 0 && block == null && block1.canPlaceBlockOnSide(this, x, y, z, side);
     }
 
-    public Path getPathToEntity(Entity entity, Entity entityToTravelTo, float distance)
+    public @Nullable Path getPathToEntity(Entity entity, Entity entityToTravelTo, float distance)
     {
         int x1 = MathHelper.floor(entity.x);
         int y2 = MathHelper.floor(entity.y);
@@ -2692,7 +2692,7 @@ public class World implements WorldSource {
         return (new PathFinder(chunkcache)).findPath(entity, entityToTravelTo, distance);
     }
 
-    public Path getEntityPathToXYZ(Entity entity, int x, int y, int z, float distance)
+    public @Nullable Path getEntityPathToXYZ(Entity entity, int x, int y, int z, float distance)
     {
         int eBlockX = MathHelper.floor(entity.x);
         int eBlockY = MathHelper.floor(entity.y);
@@ -2801,10 +2801,10 @@ public class World implements WorldSource {
         return null;
     }
 
-    public Player getPlayerEntityByUUID(UUID uuid)
+    public Player getPlayerEntityByUUID(@Nullable final UUID uuid)
     {
-        for (Player player : players) {
-            if (uuid.equals(player.uuid)) {
+        for (final Player player : this.players) {
+            if (player.uuid.equals(uuid)) {
                 return player;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
index 85c6092f5..ce5c8da06 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
@@ -8,6 +8,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 public class PathFinder
 {
@@ -24,17 +25,17 @@ public class PathFinder
         this.worldSource = worldSource;
     }
 
-    public Path findPath(Entity entity, Entity target, float distance)
+    public @Nullable Path findPath(Entity entity, Entity target, float distance)
     {
         return findPath(entity, target.x, target.bb.minY, target.z, distance);
     }
 
-    public Path findPath(Entity entity, int xt, int yt, int zt, float distance)
+    public @Nullable Path findPath(Entity entity, int xt, int yt, int zt, float distance)
     {
         return findPath(entity, (float)xt + 0.5F, (float)yt + 0.5F, (float)zt + 0.5F, distance);
     }
 
-    private Path findPath(Entity entity, double xt, double yt, double zt, float distance)
+    private @Nullable Path findPath(Entity entity, double xt, double yt, double zt, float distance)
     {
         openSet.clear();
         closedSet.clear();
@@ -44,7 +45,7 @@ public class PathFinder
         return findPath(entity, pathpoint, pathpoint1, pathpoint2, distance);
     }
 
-    private Path findPath(Entity entity, Node pathpoint, Node pathpoint1, Node pathpoint2, float f)
+    private @Nullable Path findPath(Entity entity, Node pathpoint, Node pathpoint1, Node pathpoint2, float f)
     {
         pathpoint.g = 0.0F;
         pathpoint.h = pathpoint.distanceTo(pathpoint1);
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandSave.java b/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandSave.java
index 720d1d1d4..632b0e55f 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandSave.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandSave.java
@@ -20,9 +20,8 @@ public class CommandSave implements CommandManager.CommandRegistry {
         new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.save.exception_failure", arg));
 
     public void register(CommandDispatcher<CommandSource> dispatcher) {
-        dispatcher.register
-            (
-                LiteralArgumentBuilder.<CommandSource>literal("save")
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("save")
+                    .requires(CommandSource::hasAdmin)
                     .then(LiteralArgumentBuilder.<CommandSource>literal("all").executes(c -> {
                         CommandSource source = c.getSource();
                         if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index f65d39a62..56c12ddb3 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -690,7 +690,7 @@ public class PacketHandlerServer extends PacketHandler
                 ArrayList<ItemStack> arraylist = new ArrayList<>();
                 for (int i = 0; i < playerEntity.craftingInventory.slots.size(); i++)
                 {
-                    arraylist.add(playerEntity.craftingInventory.slots.get(i).getItem());
+                    arraylist.add(playerEntity.craftingInventory.slots.get(i).getItemStack());
                 }
 
                 playerEntity.updateCraftingInventory(playerEntity.craftingInventory, arraylist);
